/*
 *	@name		gridftp.h
 *	@author		Christian Loeschen, TU Dresden
 *	@license	BSD
 */

#include "rods.h"
#include "rcConnect.h"
#include "msParam.h"

#ifndef GRIDFTPFILEDRIVER_H_
#define GRIDFTPFILEDRIVER_H_

/*
int gridFtpFileUnlink(rsComm_t *rsComm, char *filename);
int gridFtpFileStat(rsComm_t *rsComm, char *filename, struct stat *statbuf);
int gridFtpFileFsync(rsComm_t *rsComm, int fd);
int gridFtpFileMkdir(rsComm_t *rsComm, char *filename, int mode);
int gridFtpFileChmod(rsComm_t *rsComm, char *filename, int mode);
int gridFtpFileRmdir(rsComm_t *rsComm, char *filename);
int gridFtpFileReaddir(rsComm_t *rsComm, void *dirPtr, struct dirent *direntPtr);
int gridFtpFileStage(rsComm_t *rsComm, char *path, int flag);
int gridFtpFileRename(rsComm_t *rsComm, char *oldFileName, char *newFileName);
int gridFtpFileCopy(int mode, char *srcFileName, char *destFileName);
*/

/*
 * Defining GRIDFTP_DRIVER_CHANGE_FILENAME allows to use
 * GridFTP URLs missing the iRODS user home directory within.
 */
#define GRIDFTP_DRIVER_CHANGE_URL

/*
 *	Gets a file from a GridFTP file server.
 *
 *	@param rsComm			iRODS server communication handle
 *	@param cacheFileType	unused
 *	@param mode				unused
 *	@param flags			unused
 *	@param filename			destination GridFTP file URL
 *	@param cacheFilename	source file name in cache resource
 *	@param dataSize			unused
 *	@param condInput		unused
 *	@return					0 on success, 1 on failure
 */
int gridFtpStageToCache(
        rsComm_t *rsComm,
        fileDriverType_t cacheFileType,
        int mode,
        int flags,
        char *filename,
        char *cacheFilename,
        rodsLong_t dataSize,
        keyValPair_t *condInput);


/*
 *	Puts a file to a GridFTP file server.
 *
 *	@param rsComm			iRODS server communication handle
 *	@param cacheFileType	unused
 *	@param mode				unused
 *	@param flags			unused
 *	@param filename			source GridFTP file URL
 *	@param cacheFilename	destination file name in cache resource
 *	@param dataSize			unused
 *	@param condInput		unused
 *	@return					0 on success, 1 on failure
 */
int gridFtpSyncToArch(
        rsComm_t *rsComm,
        fileDriverType_t cacheFileType,
        int mode,
        int flags,
        char *filename,
        char *cacheFilename,
        rodsLong_t dataSize,
        keyValPair_t *condInput);

//int gridFtpFileCreate(rsComm_t *rsComm, char *fileName, int mode);
//int gridFtpFileOpen(rsComm_t *rsComm, char *fileName, int flags, int mode);
//int gridFtpFileRead(rsComm_t *rsComm, int fd, void *buf, int len);
//int gridFtpFileWrite(rsComm_t *rsComm, int fd, void *buf, int len);
//int gridFtpFileClose(rsComm_t *rsComm, int fd);
//int gridFtpFileFstat(rsComm_t *rsComm, int fd, struct stat *statbuf);
//rodsLong_t gridFtpFileLseek(rsComm_t *rsComm, int fd, rodsLong_t offset, int whence);
//int gridFtpFileOpendir(rsComm_t *rsComm, char *dirname, void **outDirPtr);
//int gridFtpFileClosedir(rsComm_t *rsComm, void *dirPtr);
//int gridFtpFileTruncate(rsComm_t *rsComm, char *filename, rodsLong_t dataSize);
//rodsLong_t gridFtpFileGetFsFreeSpace(rsComm_t *rsComm, char *path, int flag);

#endif /* GRIDFTPFILEDRIVER_H_ */
